#!/bin/bash
#
# source: http://zenwalk.pinguix.com/user-accounts/stillborn/b43-firmware/b43/ 
#         http://melbourne.wireless.org.au/files/wrt54/cfe.pdf
#         http://zenwalk.pinguix.com/user-accounts/stillborn/b43-firmware/README
#
# packager: stillborn (stillbornDOTzenwalkATgmailDOTcom)
#
(
#------------------Set Some Variables
set -e -u -x
buildir=$(pwd)
softname="b43-firmware"
softversion="4.178.10.4"
arch="noarch"
zenver="64.1"
package="$softname-$softversion-$arch-$zenver"
dest="$buildir/$package"

# -----------------Extract sources and get ready to build

cd $buildir
rm -rf $dest
mkdir -p $dest/install

#-----------------Make the slack-desc files

cat <<EOF > $dest/install/slack-desc
# HOW TO EDIT THIS FILE:
# The "handy ruler" below makes it easier to edit a package description.  Line
# up the first '|' above the ':' following the base package name, and the '|'
# on the right side marks the last column you can put a character in.  You must
# make exactly 11 lines for the formatting to be correct.  It's also
# customary to leave one space after the ':'.

            |-----handy-ruler----------------------------------------------|
b43-firmware: b43-firmware - Firmwares for the b43 drivers.
b43-firmware:
b43-firmware: All Broadcom chips require firmware that is loaded onto the 
b43-firmware: wireless chip before it can operate. These are the firmwares
b43-firmware: for the 802.11 B/G family of wireless chips that Broadcom
b43-firmware: produces.
b43-firmware:
b43-firmware:
b43-firmware:
b43-firmware:
b43-firmware: 
EOF

#------------------add files

cd $buildir/b43
mkdir -p $dest/lib/firmware/b43
cp -v *.fw $dest/lib/firmware/b43

mkdir -p $dest/usr/src/$softname-$softversion
cp -v $buildir/build-$softname.sh $dest/usr/src/$softname-$softversion

mkdir -p $dest/usr/doc/$softname-$softversion
cp -v $buildir/cfe.pdf $dest/usr/doc/$softname-$softversion
cp -v $buildir/README $dest/usr/doc/$softname-$softversion

#-------------------Fix permissions
(
chown -R root:root $dest
cd $dest
find . -perm 664 -exec chmod 644 {} \;
find . -perm 600 -exec chmod 644 {} \;
find . -perm 444 -exec chmod 644 {} \;
find . -perm 400 -exec chmod 644 {} \;
find . -perm 440 -exec chmod 644 {} \;
find . -perm 777 -exec chmod 755 {} \;
find . -perm 775 -exec chmod 755 {} \;
find . -perm 511 -exec chmod 755 {} \;
find . -perm 711 -exec chmod 755 {} \;
find . -perm 555 -exec chmod 755 {} \;
)

#> helperline
(cd $dest;find . -printf "%y %m %u:%g %p %l\n") >$buildir/pkgtree.log

#-------------------Make the packages and the md5sum

cd $dest
makepkg -l y -c n $dest.txz
cd $buildir
md5sum $package.txz > $package.md5
) 2>&1 | tee build-b43-firmware.log.txt
